﻿/* --- FMmarkers_Globals.jsx ------ UTF-8 ---------------------------------------------------------
              Often used constants in various scripts - can be a starter set for your project
Included by   FMmarkers.jsx
Returns       Definition of global constants, variables and arrays.
Comment       Is's less work to delete unused stuff than to look what's required and then add...
Reference     "JavaScript: The Good Parts" by Douglas Crockford [O’Reilly, 2008-05]
              is not a friend of global variables, hence I switched to object definition
History       2020-11-03 started
*/ ; // ===========================================================================================

  KLD_M.UItxt = {};                               // current texts by language switching

// === Windows ID must be set outside the dialogue function to be available for Notify functions
  wPalM  = new Window("palette", undefined, undefined);  // title set in the palette
  wPalI  = new Window("palette", undefined, undefined);  // title set in the palette
  wDlgP  = new Window("dialog", undefined, undefined);   // title set in the palette

// === 'prototype' definitions ====================================================================
KLD_M.oMarkers = function (sType, sValue, oMarker, oTr) { // NOT Used by CollectAllMarkers
  this.Type     =  sType;                         // Name of marker
  this.Value    =  sValue;                        // Contents of marker
  this.MarkerObj=  oMarker;                       // Marker object in document
  this.TextRange=  oTr;                           // textrange of this occurance in the doc
} //--- end oMarkers ----------------------------

// === Global definitions =========================================================================
  KLD_M.APP_NAME = "FMmarkers";                   // the name of the game
  KLD_M.APP_VERSION = "1.2";                      // current version of script (inc after publication)
  KLD_M.APP_LANG    = "en";                       // Will be set by SwitchUIlanguageX
  KLD_M.FM_VERSION  = 15;                         // set in Main
// --- Measurments -------------------------------
  KLD_M.MAX_MKR_VAR_LENGTH = 1024;                // Maximum contents length for markers/variables
  KLD_M.UNITBASE       = 65536;                   // internal units per PostScript point
  KLD_M.CM             = 1857713;                 // internal units per cm
  KLD_M.MM             = 185771;                  // internal units per mm
  KLD_M.PT             = 65536;                   // internal units per PostScript point and other
  KLD_M.DEGREE         = 65536;                   // internal units per degree arc.
  KLD_M.PERCENT        = 65536;                   // internal units per percent tint, shade etc.
  KLD_M.MIN            = 983;                     // minimum line width - 0.015pt
// --- Common project variables ------------------
  KLD_M.bBookActive    = undefined;
  KLD_M.bDocActive     = undefined;
  KLD_M.bIsDebug       = false;                   // true for execution of Trace calls
  KLD_M.LastDocID      = undefined;               // used in Notify
  KLD_M.oCurrentBook   = undefined;               // defined in SetupFMmarkers
// Specific for FMmarkers ------------------------
  KLD_M.oCurrentMarker = undefined;               // currently handled marker
  KLD_M.aoMarkers      = [];                      // array of markers in document
  KLD_M.iNumberMarkers = undefined;               // number of markers in array
  KLD_M.iIndexOfMarker = undefined;               // index of current marker in marker array
  KLD_M.sMfilter       = "*";                     // any type
  KLD_M.sMarkerText    = undefined;               // for dialog
  KLD_M.sMarkerType    = undefined;               // type of searched/found marker
  KLD_M.bRevise        = undefined;               // true: marker Insert called for revision; false: ordinary call
  KLD_M.bSearch        = false;                   // true: marker is searched by text
  KLD_M.iFound         = undefined;               // index of found substring (ButtonSearch)
  KLD_M.bForAll        = false;                   // concernign Replace, Change

// --- Selection lists ---------------------------
  KLD_M.asListMTypes = [];                        // to be filled by GetMarkerTypeListLocal
//KLD_M.asListObj = [];                           // filled from project xml file
  KLD_M.asListObj   = ["anchor", "backmatter", "body", "book", "chapter", "character", "flow", "font", "footer", "footnote", "format", "formula", "graphic", "header", "heading", "index", "list", "page", "paragraph", "table"];
//KLD_M.asListAct = [];                           // filled from project xml file
  KLD_M.asListAct   = ["add", "arrange", "chage", "copy", "define", "delete", "display", "distribute", "edit", "evaluae", "find", "generate", "group"];
//KLD_M.asListProp = [];                           // filled from project xml file
  KLD_M.asListProp  = ["anchored", "arow tip", "character format", "closer to", "colour", "cropped", "dashed", "floating", "hyphenation", "inside", "language", "margin", "numbering", "outside", "paragraph format", "placement", "size", "table format"];

  KLD_M.asListOper = [                            // operations in Index markers
    "<$nopage>",                                  // amended by xxx with list of character formats
    "<$startrange>",                              // encloses in <...>
    "<$endrange>",
    "<$singlepage>",
    "[sort_order]",
    "synonym → entry",
    "--- character-formats ---",
    "</>" ];

// project handling ------------------------------
//KLD_M.asListProjects = [];
  KLD_M.asListProjects = ["Template for new project", "---------------------", "Compendium", "FM_stuff", "FMcalc", "FMgraph", "FMjsxLib", "FMmarkers", "FMnotes", "FMvars"];
  KLD_M.sCurrentProject = undefined;
