﻿/* --- FMmarkers-PalM.jsx ------ UTF-8 -----------------------------------------------------------
              Palette and Call-back functions, also ancillary function for the UI
Included by   FMmarkers.jsx
Comment       Window ID must be set outside the dialogue function to be available for Notify functions
              It is set in modules FMmarkers_Globals
History       2021-04-23
*/

KLD_M.PaletteMarkers = function () { //============================================================
/*            Palette for handling all sorts of markers
Returns       The visible palette window
Called by     xxx
Calling       xxx
History       2021-09-21
*/
//wPalM  = new Window("palette", undefined, undefined);

    wPalM.text = KLD_M.UItxt.wPalM.@title.toString() + KLD_M.APP_VERSION;
    wPalM.orientation = "column";
    wPalM.alignChildren = ["left","top"];
    wPalM.spacing = 5;
    wPalM.margins = 5;

    wPalM.g1 = wPalM.add("group", undefined); // --- g1

    wPalM.g1.p1 = wPalM.g1.add("panel", undefined, KLD_M.UItxt.wPalM.@g1p1); // --- p1
//  wPalM.g1.p1.orientation = "column";
    wPalM.g1.p1.alignChildren = ["left","top"];
    wPalM.g1.p1.spacing = 5;
    wPalM.g1.p1.margins = 5;

    wPalM.g1.p1.g1 = wPalM.g1.p1.add("group", undefined, KLD_M.UItxt.wPalM.@g1p1); // --- p1
//  The automatic switching of radio buttons in the same group is violeted here,
//  because the relevant containers of the radio button is an outer group, not he immeditate group.
      wPalM.g1.p1.g1.g1 = wPalM.g1.p1.g1.add("group",undefined, undefined);
      wPalM.g1.p1.g1.g1.orientation = "column";
      	wPalM.g1.p1.g1.g1.rbAny = wPalM.g1.p1.g1.g1.add("radiobutton",undefined, KLD_M.UItxt.wPalM.@g1p1g1g1rbAny);
        wPalM.g1.p1.g1.g1.rbAny.preferredSize.width = 90;
        wPalM.g1.p1.g1.g1.rbAny.helpTip = KLD_M.UItxt.wPalM.@g1p1g1g1rbAnyhelpTip;
        wPalM.g1.p1.g1.g1.rbAny.value = true;
      	wPalM.g1.p1.g1.g1.rbTyped = wPalM.g1.p1.g1.g1.add("radiobutton",undefined, KLD_M.UItxt.wPalM.@g1p1g1g1rbTyped);
        wPalM.g1.p1.g1.g1.rbTyped.preferredSize.width = 90;
        wPalM.g1.p1.g1.g1.rbTyped.helpTip = KLD_M.UItxt.wPalM.@g1p1g1g1rbTypedhelpTip;
      wPalM.g1.p1.g1.g2 = wPalM.g1.p1.g1.add("group",undefined, undefined);
      wPalM.g1.p1.g1.g2.orientation = "column";
        wPalM.g1.p1.g1.g2.et1 = wPalM.g1.p1.g1.g2.add("edittext", undefined, " ", {boderless:true, readonly:true}); // filled dynamically
        wPalM.g1.p1.g1.g2.et1.preferredSize.width = 40;
        wPalM.g1.p1.g1.g2.et2 = wPalM.g1.p1.g1.g2.add("edittext", undefined, " ", {boderless:true, readonly:true}); // filled dynamically
        wPalM.g1.p1.g1.g2.et2.preferredSize.width = 40;

    wPalM.g1.p1.lbMtype = wPalM.g1.p1.add("listbox", undefined, undefined, {items: KLD_M.asListMTypes});
    wPalM.g1.p1.lbMtype.preferredSize = [148, 290];

// --- P2
    wPalM.g1.p2 = wPalM.g1.add("group", undefined, undefined);
    wPalM.g1.p2.orientation = "column";
    wPalM.g1.p2.alignChildren = ["left","top"];
    wPalM.g1.p2.preferredSize.height = 345;
    wPalM.g1.p2.spacing = 5;
    wPalM.g1.p2.margins = 0;
// G2
    wPalM.g1.p2.st2 = wPalM.g1.p2.add("statictext", undefined, KLD_M.UItxt.wPalM.@g1p2st2);

    wPalM.g1.p2.g2 = wPalM.g1.p2.add("group", undefined);
      wPalM.g1.p2.g2.rbNavi = wPalM.g1.p2.g2.add("radiobutton", undefined, KLD_M.UItxt.wPalM.@g1p2g2rbNavi);
      wPalM.g1.p2.g2.rbNavi.preferredSize.width = 110;
      wPalM.g1.p2.g2.rbSearch = wPalM.g1.p2.g2.add("radiobutton", undefined, KLD_M.UItxt.wPalM.@g1p2g2rbSearch);
      wPalM.g1.p2.g2.rbSearch.preferredSize.width = 120;
      wPalM.g1.p2.g2.rbCurrent = wPalM.g1.p2.g2.add("radiobutton", undefined, KLD_M.UItxt.wPalM.@g1p2g2rbCurrent);
      wPalM.g1.p2.g2.rbCurrent.preferredSize.width = 120;
//    wPalM.g1.p2.g2.cbDebug = wPalM.g1.p2.g2.add("checkbox", undefined, "Debugging"); // <<<<<<<<<<<<<<<<< Debug aid <<<<<<<<<<<<<<<
//    wPalM.Debug = wPalM.g1.p2.g2.cbDebug; // shortcut

    wPalM.g1.p2.g3 = wPalM.g1.p2.add("group", undefined);
      wPalM.g1.p2.g3.st1 = wPalM.g1.p2.g3.add("statictext", undefined, KLD_M.UItxt.wPalM.@g1p2g3st1);
      wPalM.g1.p2.g3.st1.preferredSize.width = 240;
      wPalM.g1.p2.g3.st2 = wPalM.g1.p2.g3.add("statictext", undefined, KLD_M.UItxt.wPalM.@g1p2g3st2);
      wPalM.g1.p2.g3.et1 = wPalM.g1.p2.g3.add("edittext", undefined, " ", {boderless:true, readonly:true}); // filled dynamically
      wPalM.g1.p2.g3.et1.preferredSize.width = 100;
      wPalM.g1.p2.g3.et1.graphics.font = ScriptUI.newFont ("dialog", "bold", 11);

    wPalM.g1.p2.etMark = wPalM.g1.p2.add("edittext", undefined, KLD_M.UItxt.wPalM.@g1p2etMark, {multiline: true, scrollable: true});
    wPalM.g1.p2.etMark.graphics.font = ScriptUI.newFont ("Consolas", "", 12);
    wPalM.g1.p2.etMark.preferredSize = [500, 60];
    wPalM.eMarkerTxt = wPalM.g1.p2.etMark; // ------  to the edit field ------------

// G2b
    wPalM.g1.p2.g5 = wPalM.g1.p2.add("group", undefined);
      wPalM.g1.p2.g5.st2 = wPalM.g1.p2.g5.add("statictext", undefined, KLD_M.UItxt.wPalM.@g1p2g5st2);
      wPalM.g1.p2.g5.st2.preferredSize.width = 110;
      wPalM.g1.p2.g5.cbCase = wPalM.g1.p2.g5.add("checkbox", undefined, KLD_M.UItxt.wPalM.@g1p2g5cbCase); //  Considérer le cas
      wPalM.g1.p2.g5.cbCase.preferredSize.width = 120;
      wPalM.g1.p2.g5.cbWord = wPalM.g1.p2.g5.add("checkbox", undefined, KLD_M.UItxt.wPalM.@g1p2g5cbWord); //  Mot entier
      wPalM.g1.p2.g5.cbWord.preferredSize.width = 100;
      wPalM.g1.p2.g5.cbRegEx = wPalM.g1.p2.g5.add("checkbox", undefined, KLD_M.UItxt.wPalM.@g1p2g5cbRegEx); //
// G3
    wPalM.g1.p2.g6 = wPalM.g1.p2.add("group", undefined);

      wPalM.g1.p2.g6.eSearch = wPalM.g1.p2.g6.add("edittext", undefined,  KLD_M.UItxt.wPalM.@g1p2g6eSearch);
      wPalM.g1.p2.g6.eSearch.graphics.font = ScriptUI.newFont ("Consolas", "", 12);
      wPalM.g1.p2.g6.eSearch.preferredSize.width = 300;

      wPalM.g1.p2.g6.btSearch   = wPalM.g1.p2.g6.add("button", undefined, KLD_M.UItxt.wPalM.@g1p2g6btSearch);
      wPalM.g1.p2.g6.btSearch.preferredSize.width = 80;
      wPalM.g1.p2.g6.btSearchWithin = wPalM.g1.p2.g6.add("button", undefined, KLD_M.UItxt.wPalM.@g1p2g6btSearchWithin);
      wPalM.g1.p2.g6.btSearchWithin.preferredSize.width = 100;

// P2
      wPalM.g1.p2.st3 = wPalM.g1.p2.add("statictext", undefined, KLD_M.UItxt.wPalM.@g1p2st3);

// G4
    wPalM.g1.p2.g7 = wPalM.g1.p2.add("group", undefined);

      wPalM.g1.p2.g7.eRepl = wPalM.g1.p2.g7.add("edittext", undefined, KLD_M.UItxt.wPalM.@g1p2g7eRepl);
      wPalM.g1.p2.g7.eRepl.graphics.font = ScriptUI.newFont ("Consolas", "", 12);
      wPalM.g1.p2.g7.eRepl.preferredSize.width = 300;

      wPalM.g1.p2.g7.btRepl = wPalM.g1.p2.g7.add("button", undefined, KLD_M.UItxt.wPalM.@g1p2g7btRepl);
      wPalM.g1.p2.g7.btRepl.preferredSize.width = 80;
      wPalM.g1.p2.g7.btUpdate = wPalM.g1.p2.g7.add("button", undefined, KLD_M.UItxt.wPalM.@g1p2g7btUpdate);
      wPalM.g1.p2.g7.btUpdate.preferredSize.width = 100;
// Row of change
    wPalM.g1.p2.st5 = wPalM.g1.p2.add("statictext", undefined, KLD_M.UItxt.wPalM.@g1p2st5);
    wPalM.g1.p2.g8 = wPalM.g1.p2.add("group", undefined);
      wPalM.g1.p2.g8.g9 = wPalM.g1.p2.g8.add("group", undefined);
        wPalM.g1.p2.g8.g9.lbType = wPalM.g1.p2.g8.add("listbox", undefined, undefined, {items: KLD_M.asListMTypes});
        wPalM.g1.p2.g8.g9.lbType.selection = null;
        wPalM.g1.p2.g8.g9.lbType.preferredSize = [120, 115];
      wPalM.g1.p2.g8.g10 = wPalM.g1.p2.g8.add("group", undefined);
        wPalM.g1.p2.g8.g10.btChange = wPalM.g1.p2.g8.g10.add("button", undefined, KLD_M.UItxt.wPalM.@g1p2g8g10btChange);
        wPalM.g1.p2.g8.g10.preferredSize.width = 160;
      wPalM.g1.p2.g8.g11 = wPalM.g1.p2.g8.add("group", undefined);
      wPalM.g1.p2.g8.g11.orientation = "column";
      wPalM.g1.p2.g8.g11.alignChildren = ["left","top"];
        wPalM.g1.p2.g8.g11.cbDoAll = wPalM.g1.p2.g8.g11.add ("checkbox", undefined, KLD_M.UItxt.wPalM.@g1p2g8g11cbDoAll);
        wPalM.g1.p2.g8.g11.explain = wPalM.g1.p2.g8.g11.add ("statictext", undefined , KLD_M.UItxt.wPalM.@g1p2g8g11explain, {multiline: true});

// ============================================================================= Navigation buttons
    wPalM.gNav = wPalM.add("group", undefined);
    wPalM.gNav.orientation = "row";
    wPalM.gNav.alignChildren = ["left","center"];
    wPalM.gNav.alignment = ["fill","top"];

    wPalM.gNav.st1 = wPalM.gNav.add("statictext", undefined, KLD_M.UItxt.wPalM.@gNavst1);
    wPalM.gNav.st1.justify = "right";
    wPalM.gNav.st1.preferredSize.width = 160;

    wPalM.gNav.btFirst = wPalM.gNav.add("button", undefined, "");
    wPalM.gNav.btFirst.helpTip = KLD_M.UItxt.wPalM.@gNavbtFirsthelpTip;
    wPalM.gNav.btFirst.preferredSize.width = 80;
    wPalM.gNav.btFirst.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);

    wPalM.gNav.btPrev = wPalM.gNav.add("button", undefined, "◀");
    wPalM.gNav.btPrev.helpTip = KLD_M.UItxt.wPalM.@gNavbtPrevhelpTip;
    wPalM.gNav.btPrev.preferredSize.width = 80;
    wPalM.gNav.btPrev.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);

    wPalM.gNav.btNext = wPalM.gNav.add("button", undefined, "▶");
    wPalM.gNav.btNext.helpTip = KLD_M.UItxt.wPalM.@gNavbtNexthelpTip;
    wPalM.gNav.btNext.preferredSize.width = 80;
    wPalM.gNav.btNext.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);

    wPalM.gNav.btLast = wPalM.gNav.add("button", undefined, "");
    wPalM.gNav.btLast.helpTip = KLD_M.UItxt.wPalM.@gNavbtLasthelpTip;
    wPalM.gNav.btLast.preferredSize.width = 80;
    wPalM.gNav.btLast.graphics.font = ScriptUI.newFont ("Segoe UI Symbol", "", 12);

    wPalM.gNav.space2 = wPalM.gNav.add("statictext", undefined, " ");
    wPalM.gNav.space2.preferredSize.width = 40;

    wPalM.gNav.btDel = wPalM.gNav.add("button", undefined, KLD_M.UItxt.wPalM.@gNavbtDel);
    wPalM.gNav.btDel.preferredSize.width = 95;

// ================================================================================ General buttons
    wPalM.gGen = wPalM.add("group", undefined);
    wPalM.gGen.orientation = "row";
    wPalM.gGen.alignChildren = ["left","center"];
    wPalM.gGen.spacing = 5;
    wPalM.gGen.margins = 0;

    wPalM.gGen.btHelp = wPalM.gGen.add("button", undefined, KLD_M.UItxt.wPalM.@gGenbtHelp);

    wPalM.gGen.g1 = wPalM.gGen.add("group", undefined);
    wPalM.gGen.g1.orientation = "column";
    wPalM.gGen.g1.alignChildren = ["left", "center"];
    wPalM.gGen.g1.spacing = 5;
    wPalM.gGen.g1.margins = 0;
      wPalM.gGen.g1.st1       = wPalM.gGen.g1.add ("statictext", undefined, KLD_M.UItxt.wPalM.@gGeng1st1);
      wPalM.gGen.g1.cbKeep    = wPalM.gGen.g1.add ("checkbox", undefined, undefined);
      wPalM.gGen.g1.btRefresh = wPalM.gGen.g1.add ("button", undefined, KLD_M.UItxt.wPalM.@gGenbtRefresh);

    wPalM.gGen.etInfo = wPalM.gGen.add("edittext", undefined, KLD_M.UItxt.wPalM.@gGenetInfo, {multiline: true, scrolling: true});
    wPalM.gGen.etInfo.graphics.font = ScriptUI.newFont ("Consolas", "", 12);
    wPalM.gGen.etInfo.graphics.foregroundColor = wPalM.gGen.etInfo.graphics.newPen (wPalM.gGen.etInfo.graphics.PenType.SOLID_COLOR, [1,0,0], 1);
    wPalM.gGen.etInfo.preferredSize = [405, 60];

    wPalM.gGen.btDone = wPalM.gGen.add("button", undefined, KLD_M.UItxt.wPalM.@gGenbtDone);
    wPalM.gGen.btDone.preferredSize.width = 95;

// *** behaviour functions ************************************************************************
// === behaviour of edit fields ============================================================== edit
    wPalM.g1.p2.etMark.onChange = function () {
      KLD_M.sMarkerText = wPalM.g1.p2.etMark.text;
      wPalM.g1.p2.g7.btUpdate.enabled = true;
   };

// === behaviour of the lists =============================================================== lists
// onChange would require an empty element (http://stackoverflow.com/questions/11877527)
// IMHO ondoubleClick is more user friendly as it indicates an action.
  wPalM.g1.p1.lbMtype.onDoubleClick = function () { // --- Type of marker
    var nTyped, sName;
    wPalM.gGen.etInfo.text = "";
    sName = wPalM.g1.p1.lbMtype.selection.text;
    KLD_M.sMfilter = sName;
    nTyped = KLD_M.CheckForMarker (KLD_M.oCurrentDoc, sName);
    wPalM.g1.p1.g1.g2.et2.text = nTyped;
    wPalM.g1.p1.g1.g1.rbTyped.value = true;
    if (nTyped == 0) {
      KLD_M.DisplayInfo (KLD_M.UItxt.General.@NoMarkersFound.toString(), "red");
      return;
    } else {
      KLD_M.ButtonFirstM();                       // <<<<<<<<<<<
    }
//  wPalM.g1.p1.g1.g1.rbTyped.value = true;
    wPalM.g1.p2.g8.g9.lbType.selection = null;
    if (!KLD_M.btSearch) {
      KLD_M.ActivateButtonsM ("Nav");
    } else {
      KLD_M.ActivateButtonsM ("Any");
    }
  }
  wPalM.g1.p2.g8.g9.lbType.onDoubleClick = function () { // --- new type of marker
    wPalM.g1.p2.g8.g10.btChange.enabled = true;
  }
// === behaviour of the radio buttons =============================================== radio buttons
// there must not be parameters for externalised callback functions!
  wPalM.g1.p1.g1.g1.rbAny.onClick = function () {
    KLD_M.sMfilter = "*";
    wPalM.g1.p1.lbMtype.selection = null;
    wPalM.g1.p1.g1.g2.et1.text = KLD_M.iNumberMarkers;
//   wPalM.g1.p1.g1.g1.rbTyped.value = false;
  }
  wPalM.g1.p1.g1.g1.rbTyped.onClick = function () {
    if (wPalM.g1.p1.lbMtype.selection == null) {
      wPalM.g1.p1.lbMtype.selection = 0;
    } else {
      KLD_M.sMfilter = wPalM.g1.p1.lbMtype.selection.text;
    }
//  wPalM.g1.p1.g1.g2.rbAny.value = false;
  }
  wPalM.g1.p2.g2.rbNavi.onClick = function () { // Find by navigation
    KLD_M.SearchMode (false);
    KLD_M.sMfilter = "*";
    wPalM.g1.p1.lbMtype.selection = null;
  }
  wPalM.g1.p2.g2.rbSearch.onClick = function () { // Find by search
    KLD_M.SearchMode (true);
    KLD_M.sMfilter = "*";
    wPalM.g1.p1.lbMtype.selection = null;
  }

// === behaviour of the check boxes =================================================== check boxes
  wPalM.g1.p2.g5.cbRegEx.onClick = function () {
    if (wPalM.g1.p2.g5.cbRegEx.value) {            // is this set already ?
      wPalM.g1.p2.g5.cbCase.enabled = false;
      wPalM.g1.p2.g5.cbWord.enabled = false;
    } else {
        wPalM.g1.p2.g5.cbCase.enabled = true;
        wPalM.g1.p2.g5.cbWord.enabled = true;
    }
  }
  wPalM.g1.p2.g5.cbCase.onClick = function () {
    wPalM.g1.p2.g5.cbRegEx.enabled = wPalM.g1.p2.g5.cbCase.value || wPalM.g1.p2.g5.cbWord.value ? false : true;
  }
  wPalM.g1.p2.g5.cbWord.onClick = function () {
    wPalM.g1.p2.g5.cbRegEx.enabled = wPalM.g1.p2.g5.cbCase.value || wPalM.g1.p2.g5.cbWord.value ? false : true;
  }
  wPalM.g1.p2.g8.g11.cbDoAll.onClick = function () {
    KLD_M.bForAll = wPalM.g1.p2.g8.g11.cbDoAll.value ? true : false;
  }
// === behaviour of the buttons =========================================================== buttons
// there must not be parameters for externalised callback functions!
  wPalM.g1.p2.g6.btSearch.onClick   = function () {
    wPalM.g1.p2.g2.rbCurrent.value  = false;
    KLD_M.iIndexOfMarker = KLD_M.iIndexOfMarker + 1; // search next marker
    KLD_M.ButtonSearchM ();
    wPalM.g1.p2.g8.g9.lbType.enabled   = true;
    wPalM.g1.p2.g8.g10.btChange.enabled = true;
//$.bp(true);
  }
  wPalM.g1.p2.g6.btSearchWithin.onClick = KLD_M.ButtonSearchWithinM;
  wPalM.g1.p2.g7.btRepl.onClick   = KLD_M.ButtonReplaceM;
  wPalM.g1.p2.g7.btUpdate.onClick = KLD_M.ButtonUpdateM;
  wPalM.g1.p2.g8.g10.btChange.onClick = KLD_M.ButtonChangeM;
// --- General -----------------------------------
  wPalM.gNav.btFirst.onClick = KLD_M.ButtonFirstM;
  wPalM.gNav.btPrev.onClick  = KLD_M.ButtonPreviousM;
  wPalM.gNav.btNext.onClick  = KLD_M.ButtonNextM;
  wPalM.gNav.btLast.onClick  = KLD_M.ButtonLastM;

  wPalM.gNav.btDel.onClick        = KLD_M.ButtonDeleteM;
  wPalM.gGen.g1.btRefresh.onClick = KLD_M.ButtonRefreshM;
  wPalM.gGen.btHelp.onClick       = function () {
    KLD_M.OpenHelpFile();
  }
  wPalM.gGen.btDone.onClick = function () {
    wPalM.close();
  }
// === Final work in dialogue =============================================================== final
  wPalM.g1.p2.g2.rbNavi.value     = true;
  wPalM.gGen.g1.cbKeep.value      = false;
  if (KLD_M.oCurrentMarker  === null) {
    KLD_M.HideButtonsM ();                         // also done in Notify
  }
// --- Update global arrays and populate the various selection lists -----------------
//KLD_M.iIndexOfMarker = KLD_M.RefreshGlobalsM (true);        // if null => inactivate most buttons

  wPalM.show();
} // --- end PaletteMarkers <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><

KLD_M.ActivateButtonsM = function (sGroup) { // ===================================================
/*            Hide most or all buttons
Comment       It may become necessary to handle groups on request (argument)
Called by     PaletteMarkers
Calling       -
*/
  if (sGroup == "*" || sGroup == "Any" ) { // --- tab Any marker ---------------
    wPalM.g1.p2.g6.btSearchWithin.enabled = true;
    wPalM.g1.p2.g7.btRepl.enabled   = true;
    wPalM.g1.p2.g8.g10.btChange.enabled = true;
  }
  if (sGroup == "*" || sGroup == "Nav" ) { // --- Navigation -------------------
    wPalM.gNav.btFirst.enabled              = true;
    wPalM.gNav.btPrev.enabled               = true;
    wPalM.gNav.btNext.enabled               = true;
    wPalM.gNav.btLast.enabled               = true;
  }
  wPalM.gGen.g1.btRefresh.enabled            = true;
  wPalM.gNav.btDel.enabled                   = true;
} //--- end ActivateButtonsM ----------------------------------------------------------------------

KLD_M.ButtonChangeM = function () { // ============================================================
/*            Change type of current marker
Called by     PaletteMarkers
Calling       ModifyMarker
Comment       If "Perform for all" is active, then all peritenent markers are changed
History       2021-11-16
*/
var oldType, oThisMarker, sName, sNewType;

  sNewType = wPalM.g1.p2.g8.g9.lbType.selection.text;
  KLD_M.sMarkerType = sNewType;
  if (!KLD_M.bForAll) {
    oThisMarker = KLD_M.ModifyMarker (KLD_M.oCurrentMarker, sNewType, undefined); // update only type
    KLD_M.IndicateType (KLD_M.oCurrentMarker);
    KLD_M.aoMarkers[KLD_M.iIndexOfMarker] = oThisMarker;
    KLD_M.DisplayMarker (KLD_M.oCurrentDoc, oThisMarker);
  } else {
    KLD_M.ButtonFirstM();                         // start iteration
    while (KLD_M.iIndexOfMarker < KLD_M.iNumberMarkers) {
      oThisMarker = KLD_M.ModifyMarker (KLD_M.oCurrentMarker, sNewType, undefined);
      if (KLD_M.sMfilter == "*" && KLD_M.iIndexOfMarker == KLD_M.iNumberMarkers-1) {break;}   // for *
      KLD_M.ButtonNextM();
      if (KLD_M.sMfilter != "*" && KLD_M.iIndexOfMarker == KLD_M.iNumberMarkers-1) {break;}   // for typed
    }
    wPalM.g1.p2.g8.g11.cbDoAll.value = false;     // reset to standard mode
    if (KLD_M.sMfilter == "*") {
      KLD_M.DisplayInfo (ComposeMessage(KLD_M.UItxt.ButtonChangeM.@msg_01, sNewType), "red");
    } else {
      KLD_M.DisplayInfo (ComposeMessage(KLD_M.UItxt.ButtonChangeM.@msg_02, KLD_M.sMfilter, sNewType), "red");
    }
  }
  wPalM.g1.p2.g8.g10.btChange.enabled = false;
  wPalM.g1.p2.g7.btUpdate.enabled = true;
} //---  end ButtonChangeM ------------------------------------------------------------------------

KLD_M.ButtonDeleteM = function () { // ============================================================
/*
Called by     PaletteMarkers
Calling       ButtonRefreshM
History       2021-04-23
*/
  KLD_M.oCurrentMarker.Delete();
  KLD_M.ButtonRefreshM ();                         // update globals
  wPalM.gGen.etInfo.text = "";                     // clear info area
} //---  end ButtonDeleteM ------------------------------------------------------------------------

KLD_M.ButtonFirstM = function () { // =============================================================
/*            All markers: go to first marker (of selected type)
Called by     PaletteMarkers
Calling       DisplayMarker
*/
var iMarker, iMax, sMfilter;

  wPalM.gGen.etInfo.text = "";                     // clear info area
  iMarker = KLD_M.iIndexOfMarker;
  iMax    = KLD_M.iNumberMarkers - 1;
  sMfilter  = KLD_M.sMfilter;
  iMarker = 0;
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  while (sMfilter != "*" && KLD_M.oCurrentMarker.MarkerTypeId.Name != sMfilter) {
    if (iMarker == iMax) {return; }
    iMarker = Math.min (iMax, iMarker + 1);
    KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  }
  if (sMfilter == "*") {
    KLD_M.IndicateType(KLD_M.oCurrentMarker);
  }
  KLD_M.DisplayMarker (KLD_M.oCurrentDoc, KLD_M.oCurrentMarker);
  wPalM.g1.p2.etMark.text ="";
  KLD_M.sMarkerType = KLD_M.oCurrentMarker.MarkerTypeId.Name;
  KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
  wPalM.g1.p2.etMark.text = KLD_M.sMarkerText;
  KLD_M.iIndexOfMarker = iMarker;
} //---  end ButtonFirstM -------------------------------------------------------------------------

KLD_M.ButtonInsertM = function () { // ============================================================
/*            Index maker: insert marker at current location
Called by     ButtonUpdateM, PaletteMarkers
Calling       InsertMarker, DisplayMarker
History       2021-09-22
*/
var oEditText;

  wPalM.gGen.etInfo.text = "";                     // clear info area
  if (KLD_M.oCurrentDoc.CurrentPage.type != Constants.FO_BodyPage) {
    KLD_M.DisplayInfo (KLD_M.UItxt.ButtonInsertM.@msg_01.toString(), "red");
    return;
  }
  KLD_M.iIndexOfMarker = KLD_M.InsertMarker (KLD_M.oCurrentDoc.TextSelection, KLD_M.sMarkerType, KLD_M.sMarkerText);
  if (KLD_M.iNumberMarkers == 1) {
    KLD_M.ButtonRefreshM ();                       // activate the navigation
  }
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[KLD_M.iIndexOfMarker];
  KLD_M.DisplayMarker (KLD_M.oCurrentDoc, KLD_M.oCurrentMarker);
  oEditText.text ="";
  KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
  oEditText.textselection = KLD_M.sMarkerText;
  wPalM.gGen.etInfo.text = "";                     // clear info area
} //---  end ButtonInsertM ------------------------------------------------------------------------

KLD_M.ButtonLastM = function () { // ==============================================================
/*            All markers: go to last marker (of selected type)
Called by     PaletteMarkers
Calling       DisplayMarker
*/
var iMarker, iMax, sMfilter;
//$.bp(true);
  wPalM.gGen.etInfo.text = "";                    // clear info area
  iMax     = KLD_M.iNumberMarkers - 1;
  sMfilter = KLD_M.sMfilter;
  iMarker  = iMax;
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  while (sMfilter != "*" && KLD_M.oCurrentMarker.MarkerTypeId.Name != sMfilter) {
    if (iMarker == 0) {return;}
    iMarker = Math.max (0, iMarker - 1);
    KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  }
  if (sMfilter == "*") {
    KLD_M.IndicateType(KLD_M.oCurrentMarker);
  }
  KLD_M.DisplayMarker (KLD_M.oCurrentDoc, KLD_M.oCurrentMarker);
  wPalM.g1.p2.etMark.text ="";
  KLD_M.sMarkerType = KLD_M.oCurrentMarker.MarkerTypeId.Name;
  KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
  wPalM.g1.p2.etMark.text = KLD_M.sMarkerText;
  KLD_M.iIndexOfMarker = iMarker;
} //---  end ButtonLastM ---------------------------------------------------------------------------

KLD_M.ButtonNextM = function () { // ===============================================================
/*            All markers: go to next marker (of selected type)
Called by     PaletteMarkers
Calling       DisplayMarker
*/
var iMarker, iMax, sMfilter;

wPalM.gGen.etInfo.text = "";                    // clear info area
  iMarker = KLD_M.iIndexOfMarker;
  iMax    = KLD_M.iNumberMarkers - 1;
  sMfilter  = KLD_M.sMfilter;
  if (iMarker == iMax) {
    KLD_M.DisplayInfo (KLD_M.UItxt.wPalM.@noMoreMarkers.toString(), "red");
    return;
  }
  iMarker = Math.min (iMax, iMarker + 1);         // look for next (typed) marker
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  while (sMfilter != "*" && KLD_M.oCurrentMarker.MarkerTypeId.Name != sMfilter) {
    if (iMarker == iMax) {
      KLD_M.DisplayInfo (KLD_M.UItxt.wPalM.@noMoreMarkersT.toString(), "red");
      KLD_M.iIndexOfMarker = iMarker;
      return;
    }
    iMarker = Math.min (iMax, iMarker + 1);
    KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  }
  if (sMfilter != "*" && KLD_M.oCurrentMarker.MarkerTypeId.Name == sMfilter && iMarker > iMax) {
    KLD_M.DisplayInfo (KLD_M.UItxt.wPalM.@noMoreMarkersT.toString(), "red");
    KLD_M.iIndexOfMarker = iMarker;
    return;
  }
  if (sMfilter == "*") { KLD_M.IndicateType(KLD_M.oCurrentMarker); } // Anny marker found
  KLD_M.DisplayMarker (KLD_M.oCurrentDoc, KLD_M.oCurrentMarker);
  wPalM.g1.p2.etMark.text ="";
  KLD_M.sMarkerType = KLD_M.oCurrentMarker.MarkerTypeId.Name;
  KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
  wPalM.g1.p2.etMark.text = KLD_M.sMarkerText;
  KLD_M.iIndexOfMarker = iMarker;
} //---  end ButtonNextM --------------------------------------------------------------------------

KLD_M.ButtonPreviousM = function () { // ==========================================================
/*            All markers: go to previous marker (of selected type)
Called by     PaletteMarkers
Calling       DisplayMarkerM
*/
var iMarker, sMfilter;

  wPalM.gGen.etInfo.text = "";                     // clear info area
  iMarker = KLD_M.iIndexOfMarker;
  sMfilter  = KLD_M.sMfilter;
  if (iMarker == 0) {
    KLD_M.DisplayInfo (KLD_M.UItxt.wPalM.@noMoreMarkers.toString(), "red");
    return;
  }
  iMarker = Math.max (0, iMarker - 1);
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  while (sMfilter != "*" && KLD_M.oCurrentMarker.MarkerTypeId.Name != sMfilter) {
    if (iMarker == 0) {
      KLD_M.DisplayInfo (KLD_M.UItxt.wPalM.@noMoreMarkersT.toString(), "red");
      KLD_M.iIndexOfMarker = iMarker;
      return;
    }
    iMarker = Math.max (0, iMarker - 1);
    KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  }
  if (sMfilter != "*" && KLD_M.oCurrentMarker.MarkerTypeId.Name == sMfilter &&
                                  iMarker == 0) {
    KLD_M.DisplayInfo (KLD_M.UItxt.wPalM.@noMoreMarkersT.toString(), "red");
    KLD_M.iIndexOfMarker = iMarker;
    return;
  }
  if (sMfilter == "*") {
    KLD_M.IndicateType(KLD_M.oCurrentMarker);
  }
  KLD_M.DisplayMarker (KLD_M.oCurrentDoc, KLD_M.oCurrentMarker);
  wPalM.g1.p2.etMark.text ="";
  KLD_M.sMarkerType = KLD_M.oCurrentMarker.MarkerTypeId.Name;
  KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
  wPalM.g1.p2.etMark.text = KLD_M.sMarkerText;
  KLD_M.iIndexOfMarker = iMarker;
} //---  end ButtonPreviousM ----------------------------------------------------------------------

KLD_M.ButtonRefreshM = function () { // ===========================================================
/*            Refresh internal tables (e.g. after insertion of marker
Called by     UpdateDialogues, HandleMarkers, PaletteMarkers
Calling       RefreshGlobals, DisplayMarker, ActivateButtonsM, HideButtonsM
*/
var oLocation = {}, iNewMarker ;

  KLD_M.DisplayInfo (KLD_M.UItxt.ButtonRefreshM.@msg_01);
  KLD_M.oCurrentDoc = app.ActiveDoc;
  KLD_M.sMfilter    = "*";
  iNewMarker = KLD_M.RefreshGlobalsM (false);     // hides ButtonsM, restores initial texts
  KLD_M.iIndexOfMarker = 0;
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[0];
  if (KLD_M.iIndexOfMarker  !== null) {           // --- markers found
    wPalM.g1.p2.etMark.text ="";
    KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
    wPalM.g1.p2.etMark.textselection = KLD_M.sMarkerText;
    KLD_M.ActivateButtonsM ("*");                 // activate all buttons
    KLD_M.DisplayMarker (KLD_M.oCurrentDoc, KLD_M.oCurrentMarker);
  } else {                                        // --- no markers in doc
    wPalM.g1.p2.etMark.text = KLD_M.UItxt.General.@DefaultEditText.toString();
    KLD_M.DisplayInfo (KLD_M.UItxt.General.@NoMarkersFound.toString(), "red");
    KLD_M.HideButtonsM ("*");
  }
  KLD_M.DisplayInfo (KLD_M.UItxt.ButtonRefreshM.@msg_02);
  if (!wPalM.gGen.g1.cbKeep.value) {
    wPalM.g1.p1.g1.g1.rbAny. value  = true;
//  wPalM.g1.p1.g1.g1.rbTyped.value = false;
    wPalM.g1.p2.g2.rbNavi.value     = true;
  }
} //---  end ButtonRefreshM -----------------------------------------------------------------------

KLD_M.ButtonReplaceM = function () { // ===========================================================
/*            Any marker: Replace text in marker
Called by     PaletteMarkers
Calling       xxx
*/
var bCase, bWord, indx, sEdit, sRepl, search;
//$.bp(true);
  sEdit  = wPalM.g1.p2.etMark.text;
  bCase  = wPalM.g1.p2.g5.cbCase.value;
  bWord  = wPalM.g1.p2.g5.cbWord.value;
  bRegEx = wPalM.g1.p2.g5.cbRegEx.value;
  search = wPalM.g1.p2.g6.eSearch.text;
  sRepl  = wPalM.g1.p2.g7.eRepl.text;;
  indx   = KLD_M.SearchInString (sEdit, 0, search, bCase, bWord, bRegEx);
  if (indx < 0) {
    KLD_M.DisplayInfo (KLD_M.ComposeMsg (KLD_M.UItxt.ButtonReplaceM.@msg_01, [search]), "red");

    wPalM.g1.p1.g1.g1.rbAny.value   = true;
//  wPalM.g1.p1.g1.g1.rbTyped.value = false;
    KLD_M.SearchMode (true);
    KLD_M.sMfilter = "*";
    wPalM.g1.p1.lbMtype.selection = null;
    return;
  }
  sEdit = KLD_M.ReplaceInString (sEdit, search, sRepl, bCase, bWord, bRegEx);
  wPalM.g1.p2.etMark.text = sEdit;
  KLD_M.sMarkerText = sEdit;
  KLD_M.DisplayInfo (KLD_M.UItxt.ButtonReplaceM.@msg_02, "red");
} //---  end ButtonReplaceM -----------------------------------------------------------------------

KLD_M.ButtonSearchM = function () { // ============================================================
/*            Any marker: Search text in marker
Called by     PaletteMarkers
Calling       FindMarkerByText
*/
var iMarker, iMax, sSearch, sEdit, sMtype;
function CheckTermination (search) {
  if (iMarker >= iMax) {
    KLD_M.DisplayInfo (KLD_M.ComposeMsg (KLD_M.UItxt.ButtonSearchM.@msg_01, [search]), "red");
    wPalM.g1.p2.g2.rbNavi.value = true;
    KLD_M.SearchMode (false);
    KLD_M.sMfilter = "*";
    wPalM.g1.p1.lbMtype.selection = null;
    wPalM.g1.p2.g8.g9.lbType.selection = null;
    return true;
  }
} // end CheckTermination ------------------------
  wPalM.gGen.etInfo.text = "";                     // clear info area
  if (!wPalM.g1.p2.g2.rbSearch) {return;}
  iMax    = KLD_M.iNumberMarkers;
  iMarker = KLD_M.iIndexOfMarker;
  sSearch  = wPalM.g1.p2.g6.eSearch.text;
  if (CheckTermination (sSearch)) {return;}
  sMtype  = KLD_M.sMfilter; // KLD_M.sMarkerType;
  sEdit   = wPalM.g1.p2.etMark.text;
  wPalM.g1.p2.g3.et1.text = " ";

  if (wPalM.g1.p1.g1.g1.rbAny.value) {               // search Any marker
    iMarker = KLD_M.FindMarkerByText (iMarker, sSearch, "*");
    if (iMarker < 0) {                            // no more search text in markers
      KLD_M.iIndexOfMarker = iMarker;
      return;
    }
  } else if (wPalM.g1.p1.g1.g1.rbTyped.value) {      // search typed marker
    iMarker = KLD_M.FindMarkerByText (iMarker, sSearch, sMtype);
    if (iMarker < 0) {                            // no more markers
      KLD_M.iIndexOfMarker = iMarker;
      return;
    }
  }
  if (CheckTermination (sSearch)) {return;}
  wPalM.g1.p2.g2.rbCurrent.value = true;          // handle the found text in that function
  KLD_M.iIndexOfMarker = iMarker;
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[iMarker];
  KLD_M.IndicateType(KLD_M.oCurrentMarker);
} //---  end ButtonSearchM ------------------------------------------------------------------------

KLD_M.ButtonSearchWithinM = function () { // ======================================================
/*            Any marker: Search text in marker
Called by     PaletteMarkers
Calling       DisplayInfo, IndicateType, SearchInString
*/
var bCase, bWord, iMarker, indx, sSearch, sEdit;

  wPalM.gGen.etInfo.text = "";                     // clear info area
  iMarker = KLD_M.iIndexOfMarker;
  bCase   = wPalM.g1.p2.g5.cbCase.value;
  bWord   = wPalM.g1.p2.g5.cbWord.value;
  bRegEx  = wPalM.g1.p2.g5.cbRegEx.value;
  sEdit   = wPalM.g1.p2.etMark.text;
  sSearch  = wPalM.g1.p2.g6.eSearch.text;

  indx = KLD_M.SearchInString (sEdit, KLD_M.iFound+1, sSearch, bCase, bWord, bRegEx);
  if (indx < 0) {
    KLD_M.DisplayInfo (KLD_M.ComposeMsg (KLD_M.UItxt.ButtonSearchWithinM.@msg_01, [search]), "red");
    wPalM.g1.p2.g2.rbSearch.value = true;
    iMarker = iMarker + 1;                        // search next marker
  } else {
    // found in current marker on position
    KLD_M.iFound =  KLD_M.iFound + indx;
    wPalM.g1.p2.g3.et1.text = wPalM.g1.p2.g3.et1.text + ", " + KLD_M.iFound; // .toString();
    KLD_M.iFound =  KLD_M.iFound + sSearch.length + 1;  // for next search in same text
  }
  KLD_M.iIndexOfMarker = iMarker;
} //---  end ButtonSearchWithinM ------------------------------------------------------------------

KLD_M.ButtonUpdateM = function () { // ============================================================
/*            Update current marker (type, contents)
Called by     PaletteMarkers
Calling       ModifyMarker, DisplayMarker, HideButtonsM
Comment       A hidden marker on the master page is used for this process
History       2021-11-16
*/
var jMark, sEdit, sMtype, oThisMarker;

  wPalM.gGen.etInfo.text = "";                    // clear info area
  sEdit  = wPalM.g1.p2.etMark.text;               // new contents
  sMtype = KLD_M.sMarkerType;                     // new type
  jMark  = KLD_M.iIndexOfMarker;                  // this is not changed

  oThisMarker = KLD_M.ModifyMarker (KLD_M.oCurrentMarker, undefined, sEdit); // update only MarkerText
  KLD_M.sMarkerText = sEdit;                      // update globals
  KLD_M.aoMarkers[KLD_M.iIndexOfMarker] = oThisMarker;
  KLD_M.DisplayMarker (KLD_M.oCurrentDoc, oThisMarker);
  wPalM.gGen.etInfo.text = "";
} //---  end ButtonUpdateM ------------------------------------------------------------------------

KLD_M.HideButtonsM = function (sGroup) { // =======================================================
/*            Hide most or all buttons
Comment       It may become necessary to handle groups on request (argument)
Called by     PaletteMarkers
Calling       -
*/
  if (sGroup = "*" || sGroup == "Any" ) { // --- tab Any marker ---------------
    wPalM.g1.p2.g6.btSearchWithin.enabled   = false;
    wPalM.g1.p2.g7.btRepl.enabled           = false;
    wPalM.g1.p2.g8.g10.btChange.enabled     = false;
  }

  if (sGroup = "*" || sGroup == "Nav" ) { // --- Navigation -------------------
    wPalM.gNav.btFirst.enabled              = false;
    wPalM.gNav.btPrev.enabled               = false;
    wPalM.gNav.btNext.enabled               = false;
    wPalM.gNav.btLast.enabled               = false;
  }
  wPalM.gGen.g1.btRefresh.enabled           = true;
  wPalM.gNav.btDel.enabled                  = true;
} //--- end HideButtonsM --------------------------------------------------------------------------

KLD_M.IndicateType = function (oMarker) { // ======================================================
/*            Indicate the type of current marker in the type list by simple selection
*/
var j, nTypes, sChild, sType;
  sType = oMarker.MarkerTypeId.Name;
  nTypes = wPalM.g1.p1.lbMtype.children.length;
  for (j = 0; j < nTypes; j++) {
    sChild = wPalM.g1.p1.lbMtype.children[j];
    if (wPalM.g1.p1.lbMtype.children[j].text == sType) {
      wPalM.g1.p1.lbMtype.children[j].selected   = true;
      wPalM.g1.p2.g8.g9.lbType.children[j].selected = true;
      return;
    }
  }
} //--- end IndicateType --------------------------------------------------------------------------

KLD_M.RefreshGlobalsM = function (isFirst) { // ===================================================
/*            Fill the global arrays relevant for PaletteMarkers.
Arguments     isFirst         true if called from Palette, false if called from Notify
Returns       Index of marker after the current location
Called by     PaletteMarkers, ButtonRefreshM
Calling       CollectAllMarkers, GetIndexOfMarker, GetIndexNearestMarker,
              RestoreLocation, SaveCurrentLocation,
*/
var aOptSave = [], oDoc = app.ActiveDoc, oLocation;

  KLD_M.oCurrentDoc = oDoc;
  if (!oDoc.ObjectValid()) {
    return null;                                  // no document open
  }
//KLD_M.SetDisplay (false);                       // avoid flicker
  if (wPalM.gGen.g1.cbKeep.value) {               // preserve option settings
    aOptSave[0] = wPalM.g1.p1.g1.g1.rbAny.value;
    aOptSave[1] = wPalM.g1.p1.g1.g1.rbTyped.value;
    aOptSave[2] = wPalM.g1.p2.g2.rbNavi.value;
    aOptSave[3] = wPalM.g1.p2.g2.rbSearch.value;
    aOptSave[4] = wPalM.g1.p2.g2.rbCurrent.value;
    aOptSave[5] = wPalM.g1.p2.g5.cbCase.value;
    aOptSave[6] = wPalM.g1.p2.g5.cbWord.value;
    aOptSave[7] = wPalM.g1.p2.g5.cbRegEx.value;
  }
  KLD_M.iNumberMarkers = KLD_M.CollectAllMarkers (KLD_M.aoMarkers); // last marker may have updated
  wPalM.g1.p1.g1.g2.et1.text = KLD_M.iNumberMarkers;
  KLD_M.GetMarkerTypeListLocal (KLD_M.oCurrentDoc, KLD_M.asListMTypes);
  KLD_M.FillDlgList (wPalM.g1.p1.lbMtype, KLD_M.asListMTypes);
  KLD_M.FillDlgList (wPalM.g1.p2.g8.g9.lbType, KLD_M.asListMTypes);

  if (KLD_M.bRevise) {                            // marker already known
    KLD_M.iIndexOfMarker = KLD_M.GetIndexOfMarker (KLD_M.aoMarkers, KLD_M.oCurrentMarker);
  } else {
    if (KLD_M.iNumberMarkers  === null || isFirst)  {
      KLD_M.DisplayInfo (KLD_M.UItxt.General.@NoMarkersFound.toString(), "red");
      KLD_M.HideButtons ("*");
      return null;
    } else {
      KLD_M.iIndexOfMarker = KLD_M.GetIndexNearestMarker (KLD_M.aoMarkers, KLD_M.sMfilter);
      if (KLD_M.iIndexOfMarker  === null) {KLD_M.iIndexOfMarker = 0;} // no selection in doc
    }
  }
  KLD_M.oCurrentMarker = KLD_M.aoMarkers[KLD_M.iIndexOfMarker];
  KLD_M.sMarkerText = KLD_M.oCurrentMarker.MarkerText;
  KLD_M.bRevise = false;                          // next entry is ordinary
  if (wPalM.gGen.g1.cbKeep.value) {               // restore option settings
//  wPalM.g1.p1.g1.g1.rbAny.value  = aOptSave[0];
    wPalM.g1.p2.g2.rbSearch.value  = aOptSave[3];
    wPalM.g1.p1.g1.g1.rbTyped.value= aOptSave[1];
    wPalM.g1.p2.g2.rbNavi.value    = aOptSave[2];
    wPalM.g1.p2.g2.rbCurrent.value = aOptSave[4];
    wPalM.g1.p2.g5.cbCase.value    = aOptSave[5];
    wPalM.g1.p2.g5.cbWord.value    = aOptSave[6];
    wPalM.g1.p2.g5.cbRegEx.value   = aOptSave[7];
  }

//KLD_M.RestoreLocation (oDoc, oLocation);        // Restore  cursor location/TR
//KLD_M.SetDisplay (true);
  return KLD_M.iIndexOfMarker;
} //--- end RefreshGlobalsM -----------------------------------------------------------------------

KLD_M.SearchMode = function (bSearch) { // ========================================================
/*            Define availability of "change marker type" and navigation
Arguments     bSearch         true = search mode
                              false = navigation mode
Returns       -
Called by     PaletteMarkers
History       2021-10-02
*/
    KLD_M.bSearch = bSearch;
    wPalM.g1.p2.g8.g9.lbType.selection = bSearch ? null : 0;
    if (bSearch) KLD_M.ActivateButtonsM("Any");
    wPalM.g1.p2.g8.g9.enabled = bSearch;             // change group
    wPalM.gNav.enabled = !bSearch;                // nav group
    wPalM.g1.p1.g1.g1.rbAny.value   = true;
//  wPalM.g1.p1.g1.g1.rbTyped.value = false;
    wPalM.g1.p2.g6.enabled = bSearch;
    wPalM.g1.p2.g7.enabled = bSearch;
    KLD_M.iIndexOfMarker = 0;                     // start searches at the beginning
} // --- end SearchMode ---------------------------------------------------------------------------
